/* ****************************
  ESP NOW CLIENT (TRANSMITTER, SENDER, MASTER)
 * *************************** */

#pragma once

uint8_t serverAddress[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};     // broadcast MAC address to send to all servers
//uint8_t serverAddress[] = {0xA0, 0xA3, 0xB3, 0xFF, 0x53, 0x30};   //custom MAC address to send to one specific server

extern uint16_t actualPattern;                                      // defined in main tab - needed for the message
extern Message messageData;                                         // defined in main tab - needed for the message

esp_now_peer_info_t peerInfo;

// the send function to transmit the payload
void clientTransmit() {
  //messageData.id = 0;      // ready for future usage (rfu)
  messageData.index = actualPattern;
  esp_err_t result = esp_now_send(serverAddress, (uint8_t *) &messageData, sizeof(messageData));
  if (result != ESP_OK) {
    Serial.println("Sending error");
  }
}

// callback when message was sent
void clientOnDataSent(const uint8_t *macAddress, esp_now_send_status_t sendStatus) {
  Serial.printf("to %02x:%02x:%02x:%02x:%02x:%02x ",  macAddress[0], macAddress[1], macAddress[2], macAddress[3], macAddress[4], macAddress[5]);
  if (sendStatus == ESP_NOW_SEND_SUCCESS) {
    Serial.println("sent");
  } else {
    Serial.println("ERROR: sent failed!");
  }
}

// to be called in setup
void clientSetup() {
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error init ESP-NOW");
    return;
  }
  esp_now_register_send_cb(clientOnDataSent);
  memcpy(peerInfo.peer_addr, serverAddress, sizeof(serverAddress) / sizeof(serverAddress[0]));
  peerInfo.channel = 0;
  peerInfo.encrypt = false;
  if (esp_now_add_peer(&peerInfo) != ESP_OK) {
    Serial.println("Failed to add peer");
    return;
  }
}
//
